package ovh.herisson.Clyde.Services;

import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.InscriptionRepository;
import ovh.herisson.Clyde.Tables.InscriptionRequest;
import ovh.herisson.Clyde.Tables.RequestState;

@Service
public class InscriptionService {

    InscriptionRepository inscriptionRepo;

    public InscriptionService(InscriptionRepository inscriptionRepo){
        this.inscriptionRepo = inscriptionRepo;
    }

    public InscriptionRequest save(InscriptionRequest inscriptionRequest){
        return inscriptionRepo.save(inscriptionRequest);
    }

    public InscriptionRequest getById(long id){
        return inscriptionRepo.findById(id);
    }

    public Iterable<InscriptionRequest> getAll(){
        return inscriptionRepo.findAll();
    }

    public boolean modifyState(long id, RequestState requestState) {
        InscriptionRequest inscriptionRequest = getById(id);

        if (inscriptionRequest == null)
            return false;

        // if th state is the same we don't send an email
        if (requestState == inscriptionRequest.getState())
            return false;

        /** todo send an email to tell the poster of the inscriptionRequest (inscriptionRequest.getEmail())
         *  to notify them that the state of their request changed
         *  FooEmailFormat toSend = (String.format("Your request state changed from %s to %s"),
         *                                              inscriptionRequest.getState(), requestState)
         * FooEmailSender.send(toSend, inscriptionRequest.getEmail())
         */
        inscriptionRequest.setState(requestState);
        save(inscriptionRequest);
        return true;
    }
}
